#!/bin/sh
if [ x"$1" = x"--help" ]; then
	echo "extractbuddy.sh by Daniel Reed <n@ml.org>"
	echo "  Extracts buddy screen names from .faimrc files."
	echo
	echo "Usage: $0 [<infile> [<outfile>]]"
	echo "  Where <infile> is a valid .faimrc file and <outfile> is the name of the"
	echo "  file that will contain the buddies. If <outfile> is not listed, stdout"
	echo "  is used. Likewise, if no <infile> is given, extractbuddy will expect"
	echo "  input from stdin."
	exit
fi

if [ x"$2" = x ]; then
	if [ x"$1" = x ]; then
		grep \^buddy | gawk '{print $2}'
	else
		cat "$1" | grep \^buddy | gawk '{print $2}'
	fi
else
	if [ x"$1" = x ]; then
		grep \^buddy | gawk '{print $2}' > "$2"
	else
		cat "$1" | grep \^buddy | gawk '{print $2}' > "$2"
	fi
fi
