/*  _ __   __ _ ___ __  __
** | '_ \ / _` |_ _|  \/  | naim
** | | | | (_| || || |\/| | Copyright 1998, 1999 Daniel Reed <n@ml.org>
** |_| |_|\__,_|___|_|  |_| ncurses-based, FAIM-based AIM client
** 
** FAIM Copyright 1998 Adam Fritzler <afritz@iname.com>
** FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
*/
#include <naim.h>

char	*firstatom(char *string, char *bounds) {
	assert(string != NULL);
	assert(bounds != NULL);
	assert(*bounds != 0);
	if (*string == 0)
		return(string);
	while (*string && (strchr(bounds, *string) == NULL))
		string++;
	if (*string) {
		*string = 0;
		string++;
	} else
		string = NULL;
	return(string);
}

char	*firstwhite(char *string) {
	char	inquote = 0;

	assert(string != NULL);
	if (*string == 0)
		return(string);
	while (*string && (isspace(*string)))
		string++;		// skip over leading whitespace
	while (*string && (inquote || (!isspace(*string)))) {
		if (*string == '"') {
			if (!inquote)
				inquote = 1;
			else
				break;
		}
		string++;		// then skip over the first word
	}
	if (*string) {
		*string = 0;
		string++;
		while (isspace(*string))
			string++;	// skip over trailing whitespace
	} else
		string = NULL;
	return(string);
}

char	*atom(char *string) {
	while (*string && ((isspace(*string)) || (*string == '"')))
		string++;		// skip over leading whitespace
	return(string);
}
