/*  _ __   __ _ ___ __  __
** | '_ \ / _` |_ _|  \/  | naim
** | | | | (_| || || |\/| | Copyright 1998, 1999 Daniel Reed <n@ml.org>
** |_| |_|\__,_|___|_|  |_| ncurses-based, FAIM-based AIM client
**
** FAIM Copyright 1998 Adam Fritzler <afritz@iname.com>
** FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
*/
#include <naim.h>

extern WINDOW	*win_status;
extern buddywin_t	*curbwin, nullbwin;
extern int	wsetup_called;
FILE	*dfile = NULL;

int	dprintf(const char *format, ...) {
	char	buf[11];
	va_list	msg;
	time_t	t = time(NULL);
	struct tm	*tptr = localtime(&t);

	if (dfile == NULL)
		dfile = fopen("naim.debug", "wa");
	assert(format != NULL);
	while (*format == '\n')
		format++;
	snprintf(buf, sizeof(buf), "[%02i:%02i:%02i]", tptr->tm_hour,
		tptr->tm_min, tptr->tm_sec);
	fprintf(dfile, "%s !!! ", buf);
	va_start(msg, format);
	vfprintf(dfile, format, msg);
	va_end(msg);
	fflush(dfile);
	if (wsetup_called == 1) {
		wattrset(win_status, COLOR_PAIR(STAT_TEXT));
		waddstr(win_status, buf);
		wattrset(win_status, A_BOLD | COLOR_PAIR(IMWIN_TEXT_U));
		waddstr(win_status, " !!! ");
		wattrset(win_status, A_BOLD | COLOR_PAIR(STAT_TEXT));
		va_start(msg, format);
		vwprintw(win_status, format, msg);
		va_end(msg);
		wattrset(win_status, 0);
		nullbwin.waiting = 1;
		bupdate();
		if (curbwin->win == win_status)
			wrefresh(win_status);
	} else if (wsetup_called == 2) {
		va_start(msg, format);
		vwprintw(stdscr, format, msg);
		va_end(msg);
		wrefresh(stdscr);
	} else {
		va_start(msg, format);
		vprintf(format, msg);
		va_end(msg);
	}
	return(1);
}
