/*  _ __   __ _ ___ __  __
** | '_ \ / _` |_ _|  \/  | naim
** | | | | (_| || || |\/| | Copyright 1998, 1999 Daniel Reed <n@ml.org>
** |_| |_|\__,_|___|_|  |_| ncurses-based, FAIM-based AIM client
** 
** FAIM Copyright 1998 Adam Fritzler <afritz@iname.com>
** FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
*/
#include <naim.h>

extern WINDOW	*win_status;
extern buddywin_t	nullbwin;
extern faimconf_t	faimconf;
time_t	idlesince = 0;
int	iamaway = 0;

void	logim(char *source, char *target, char *msg) {
	static FILE	*logfile;
	time_t	t = 0;

	if (faimconf.nolog == 1)
		return;
	t = time(NULL);
	assert(t != 0);
	if ((source == NULL) && (target == NULL) && (msg != NULL)
		&& (*msg != 0)) {
		struct tm	*tmptr = NULL;

		tmptr = localtime(&t);
		assert(tmptr != NULL);
		if ((logfile = fopen(msg, "a")) == NULL)
			printf("Unable to open \"%s\": %m", msg);
		fprintf(logfile, "\n*** Log opened %02i-%02i-%04i at"
			" %02i:%02i.\n", tmptr->tm_mon+1, tmptr->tm_mday,
			1900+tmptr->tm_year, tmptr->tm_hour,
			tmptr->tm_min);
		return;
	}
	assert(source != NULL);
	assert(*source != 0);
	assert(target != NULL);
	assert(*target != 0);
	assert(target != NULL);
	assert(*target != 0);
	fprintf(logfile, "%lu %10s | %10s | %s\n", t, source, target,
		msg);
	fflush(logfile);
}

void	naim_send_im(char *SN, char *msg) {
	aim_send_im(SN, msg);
}

void	naim_send_im_away(char *SN, char *msg) {
	printf("Sent away IM to %s (%s)\n", SN, msg);
	aim_send_im_away(SN, msg);
}

void	setaway(void) {
	iamaway = 1;
	idlesince = time(NULL);
	printf("You are now away--hurry back!\n");
}

void	unsetaway(void) {
	iamaway = 0;
	idlesince = 0;
	printf("You are no longer away--welcome back =)\n");
}

void	sendaway(char *SN) {
	char	buf[1124];
	struct tm	*tmptr = NULL;

	if (iamaway == 0)
		return;
	assert(idlesince != 0);
	tmptr = localtime(&idlesince);
	assert(tmptr != NULL);
	snprintf(buf, sizeof(buf), "[Away since %02i/%02i at %02i:%02i] %s",
		1+tmptr->tm_mon, tmptr->tm_mday, tmptr->tm_hour,
		tmptr->tm_min, faimconf.awaymsg);
	naim_send_im_away(SN, buf);
}
